// Code generated by client-gen. DO NOT EDIT.

package v1alpha1

import (
	"context"
	"time"

	v1alpha1 "github.com/karmada-io/karmada/pkg/apis/autoscaling/v1alpha1"
	scheme "github.com/karmada-io/karmada/pkg/generated/clientset/versioned/scheme"
	v1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	types "k8s.io/apimachinery/pkg/types"
	watch "k8s.io/apimachinery/pkg/watch"
	rest "k8s.io/client-go/rest"
)

// CronFederatedHPAsGetter has a method to return a CronFederatedHPAInterface.
// A group's client should implement this interface.
type CronFederatedHPAsGetter interface {
	CronFederatedHPAs(namespace string) CronFederatedHPAInterface
}

// CronFederatedHPAInterface has methods to work with CronFederatedHPA resources.
type CronFederatedHPAInterface interface {
	Create(ctx context.Context, cronFederatedHPA *v1alpha1.CronFederatedHPA, opts v1.CreateOptions) (*v1alpha1.CronFederatedHPA, error)
	Update(ctx context.Context, cronFederatedHPA *v1alpha1.CronFederatedHPA, opts v1.UpdateOptions) (*v1alpha1.CronFederatedHPA, error)
	UpdateStatus(ctx context.Context, cronFederatedHPA *v1alpha1.CronFederatedHPA, opts v1.UpdateOptions) (*v1alpha1.CronFederatedHPA, error)
	Delete(ctx context.Context, name string, opts v1.DeleteOptions) error
	DeleteCollection(ctx context.Context, opts v1.DeleteOptions, listOpts v1.ListOptions) error
	Get(ctx context.Context, name string, opts v1.GetOptions) (*v1alpha1.CronFederatedHPA, error)
	List(ctx context.Context, opts v1.ListOptions) (*v1alpha1.CronFederatedHPAList, error)
	Watch(ctx context.Context, opts v1.ListOptions) (watch.Interface, error)
	Patch(ctx context.Context, name string, pt types.PatchType, data []byte, opts v1.PatchOptions, subresources ...string) (result *v1alpha1.CronFederatedHPA, err error)
	CronFederatedHPAExpansion
}

// cronFederatedHPAs implements CronFederatedHPAInterface
type cronFederatedHPAs struct {
	client rest.Interface
	ns     string
}

// newCronFederatedHPAs returns a CronFederatedHPAs
func newCronFederatedHPAs(c *AutoscalingV1alpha1Client, namespace string) *cronFederatedHPAs {
	return &cronFederatedHPAs{
		client: c.RESTClient(),
		ns:     namespace,
	}
}

// Get takes name of the cronFederatedHPA, and returns the corresponding cronFederatedHPA object, and an error if there is any.
func (c *cronFederatedHPAs) Get(ctx context.Context, name string, options v1.GetOptions) (result *v1alpha1.CronFederatedHPA, err error) {
	result = &v1alpha1.CronFederatedHPA{}
	err = c.client.Get().
		Namespace(c.ns).
		Resource("cronfederatedhpas").
		Name(name).
		VersionedParams(&options, scheme.ParameterCodec).
		Do(ctx).
		Into(result)
	return
}

// List takes label and field selectors, and returns the list of CronFederatedHPAs that match those selectors.
func (c *cronFederatedHPAs) List(ctx context.Context, opts v1.ListOptions) (result *v1alpha1.CronFederatedHPAList, err error) {
	var timeout time.Duration
	if opts.TimeoutSeconds != nil {
		timeout = time.Duration(*opts.TimeoutSeconds) * time.Second
	}
	result = &v1alpha1.CronFederatedHPAList{}
	err = c.client.Get().
		Namespace(c.ns).
		Resource("cronfederatedhpas").
		VersionedParams(&opts, scheme.ParameterCodec).
		Timeout(timeout).
		Do(ctx).
		Into(result)
	return
}

// Watch returns a watch.Interface that watches the requested cronFederatedHPAs.
func (c *cronFederatedHPAs) Watch(ctx context.Context, opts v1.ListOptions) (watch.Interface, error) {
	var timeout time.Duration
	if opts.TimeoutSeconds != nil {
		timeout = time.Duration(*opts.TimeoutSeconds) * time.Second
	}
	opts.Watch = true
	return c.client.Get().
		Namespace(c.ns).
		Resource("cronfederatedhpas").
		VersionedParams(&opts, scheme.ParameterCodec).
		Timeout(timeout).
		Watch(ctx)
}

// Create takes the representation of a cronFederatedHPA and creates it.  Returns the server's representation of the cronFederatedHPA, and an error, if there is any.
func (c *cronFederatedHPAs) Create(ctx context.Context, cronFederatedHPA *v1alpha1.CronFederatedHPA, opts v1.CreateOptions) (result *v1alpha1.CronFederatedHPA, err error) {
	result = &v1alpha1.CronFederatedHPA{}
	err = c.client.Post().
		Namespace(c.ns).
		Resource("cronfederatedhpas").
		VersionedParams(&opts, scheme.ParameterCodec).
		Body(cronFederatedHPA).
		Do(ctx).
		Into(result)
	return
}

// Update takes the representation of a cronFederatedHPA and updates it. Returns the server's representation of the cronFederatedHPA, and an error, if there is any.
func (c *cronFederatedHPAs) Update(ctx context.Context, cronFederatedHPA *v1alpha1.CronFederatedHPA, opts v1.UpdateOptions) (result *v1alpha1.CronFederatedHPA, err error) {
	result = &v1alpha1.CronFederatedHPA{}
	err = c.client.Put().
		Namespace(c.ns).
		Resource("cronfederatedhpas").
		Name(cronFederatedHPA.Name).
		VersionedParams(&opts, scheme.ParameterCodec).
		Body(cronFederatedHPA).
		Do(ctx).
		Into(result)
	return
}

// UpdateStatus was generated because the type contains a Status member.
// Add a +genclient:noStatus comment above the type to avoid generating UpdateStatus().
func (c *cronFederatedHPAs) UpdateStatus(ctx context.Context, cronFederatedHPA *v1alpha1.CronFederatedHPA, opts v1.UpdateOptions) (result *v1alpha1.CronFederatedHPA, err error) {
	result = &v1alpha1.CronFederatedHPA{}
	err = c.client.Put().
		Namespace(c.ns).
		Resource("cronfederatedhpas").
		Name(cronFederatedHPA.Name).
		SubResource("status").
		VersionedParams(&opts, scheme.ParameterCodec).
		Body(cronFederatedHPA).
		Do(ctx).
		Into(result)
	return
}

// Delete takes name of the cronFederatedHPA and deletes it. Returns an error if one occurs.
func (c *cronFederatedHPAs) Delete(ctx context.Context, name string, opts v1.DeleteOptions) error {
	return c.client.Delete().
		Namespace(c.ns).
		Resource("cronfederatedhpas").
		Name(name).
		Body(&opts).
		Do(ctx).
		Error()
}

// DeleteCollection deletes a collection of objects.
func (c *cronFederatedHPAs) DeleteCollection(ctx context.Context, opts v1.DeleteOptions, listOpts v1.ListOptions) error {
	var timeout time.Duration
	if listOpts.TimeoutSeconds != nil {
		timeout = time.Duration(*listOpts.TimeoutSeconds) * time.Second
	}
	return c.client.Delete().
		Namespace(c.ns).
		Resource("cronfederatedhpas").
		VersionedParams(&listOpts, scheme.ParameterCodec).
		Timeout(timeout).
		Body(&opts).
		Do(ctx).
		Error()
}

// Patch applies the patch and returns the patched cronFederatedHPA.
func (c *cronFederatedHPAs) Patch(ctx context.Context, name string, pt types.PatchType, data []byte, opts v1.PatchOptions, subresources ...string) (result *v1alpha1.CronFederatedHPA, err error) {
	result = &v1alpha1.CronFederatedHPA{}
	err = c.client.Patch(pt).
		Namespace(c.ns).
		Resource("cronfederatedhpas").
		Name(name).
		SubResource(subresources...).
		VersionedParams(&opts, scheme.ParameterCodec).
		Body(data).
		Do(ctx).
		Into(result)
	return
}
